diff --git a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
index fc9f9db3f..9dc7e64e9 100644
--- a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
 import java.util.Random;
 
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.item.block.BlockItem;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.core.block.Block;
@@ -13,19 +13,19 @@ import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
+import org.lwjgl.opengl.GL12;
 
 import static org.lwjgl.opengl.GL11.glPushMatrix;
 
 // Referenced classes of package net.minecraft.src:
-//            Render, RenderBlocks, EntityItem, MathHelper,
+//            Render, RenderBlocks, ItemEntity, MathHelper,
 //            ItemStack, Block, Tessellator, Item,
 //            RenderManager, RenderEngine, FontRenderer, Entity
 
-public class ItemEntityRenderer extends EntityRenderer<EntityItem>
+public class ItemEntityRenderer extends EntityRenderer<ItemEntity>
 {
 	public final RenderBlocks renderBlocks;
 	private final Random random;
@@ -40,14 +40,14 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 	}
 
 	public int getItemColorFromMetadata(Item item, int metadata) {
-		if (item instanceof ItemBlock) {
-			Block block = ((ItemBlock)item).getBlock();
+		if (item instanceof BlockItem) {
+			Block block = ((BlockItem)item).getBlock();
 			return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
 		}
 		return 0xFFFFFF;
 	}
 
-	public void doRender(Tessellator tessellator, final EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+	public void render(Tessellator tessellator, final ItemEntity entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
 		float brightness = 1.0f;
 		if(!LightmapHelper.isLightmapEnabled()) {
 			brightness = entity.getBrightness(partialTick);
@@ -62,8 +62,8 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 			return;
 		}
 		glPushMatrix();
-		final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.initialRotation) * 0.1F + 0.1F;
-		final float f3 = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.initialRotation));
+		final float bobbingOffset = MathHelper.sin((entity.age + partialTick) / 10F + entity.bobOffset) * 0.1F + 0.1F;
+		final float f3 = (float) Math.toDegrees(((entity.age + partialTick) / 20F + entity.bobOffset));
 		byte renderCount = 1;
 		if (entity.item.stackSize > 1) {
 			renderCount = 2;
@@ -75,12 +75,12 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 			renderCount = 4;
 		}
 		GL11.glTranslatef((float) x, (float) y + bobbingOffset, (float) z);
-		GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+		GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 		GL11.glEnable(GL11.GL_BLEND);
 		BlockModel.setRenderBlocks(renderBlocks);
 		ItemModelDispatcher.getInstance().getDispatch(item).renderAsItemEntity(Tessellator.instance, entity, random, itemstack, renderCount, f3, brightness, partialTick);
 		GL11.glDisable(GL11.GL_BLEND);
-		GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+		GL11.glDisable(GL12.GL_RESCALE_NORMAL);
 		GL11.glPopMatrix();
 	}
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java b/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java
index bc92080ec..a90031aa6 100644
--- a/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/LightningBoltRenderer.java
@@ -3,26 +3,26 @@ package net.minecraft.client.render.entity;
 import java.util.Random;
 
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.EntityLightningBolt;
+import net.minecraft.core.entity.LightningEntity;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            Render, Tessellator, EntityLightningBolt, Entity
+//            Render, Tessellator, LightningEntity, Entity
 
-public class LightningBoltRenderer extends EntityRenderer<EntityLightningBolt>
+public class LightningBoltRenderer extends EntityRenderer<LightningEntity>
 {
 
     public LightningBoltRenderer()
     {
     }
 
-    public void func_27002_a(EntityLightningBolt lightningBolt, double d, double d1, double d2,
+    public void func_27002_a(LightningEntity lightningBolt, double d, double d1, double d2,
                              float f, float f1)
     {
         Tessellator tessellator = Tessellator.instance;
-        GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
-        GL11.glDisable(2896 /*GL_LIGHTING*/);
-        GL11.glEnable(3042 /*GL_BLEND*/);
+        GL11.glDisable(GL11.GL_TEXTURE_2D);
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(770, 1);
         double ad[] = new double[8];
         double ad1[] = new double[8];
@@ -113,14 +113,14 @@ public class LightningBoltRenderer extends EntityRenderer<EntityLightningBolt>
 
         }
 
-        GL11.glDisable(3042 /*GL_BLEND*/);
-        GL11.glEnable(2896 /*GL_LIGHTING*/);
-        GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_LIGHTING);
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
     }
 
     @Override
-    public void doRender(Tessellator tessellator, EntityLightningBolt entity, double x, double y, double z,
-                         float yaw, float partialTick)
+    public void render(Tessellator tessellator, LightningEntity entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         func_27002_a(entity, x, y, z, yaw, partialTick);
     }
diff --git a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
index 1e97d4b8f..46e873873 100644
--- a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
@@ -2,125 +2,136 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelMinecart;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.client.render.model.MinecartModel;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.opengl.GL11;
 
-// Referenced classes of package net.minecraft.src:
-//            Render, ModelMinecart, EntityMinecart, Vec3D, 
-//            MathHelper, RenderBlocks, Block, ModelBase, 
-//            Entity
-
-public class MinecartRenderer extends EntityRenderer<EntityMinecart>
-{
-
-    public MinecartRenderer()
-    {
+public class MinecartRenderer extends EntityRenderer<MinecartEntity> {
+    public MinecartRenderer() {
         shadowSize = 0.5F;
-        modelMinecart = new ModelMinecart();
+        modelMinecart = new MinecartModel();
     }
 
-    public void renderMinecart(EntityMinecart minecart, double d, double d1, double d2,
-                               float f, float f1)
-    {
+    @Override
+    public void render(Tessellator tessellator, MinecartEntity minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
         GL11.glPushMatrix();
+        
+        double lerpX = MathHelper.lerp(minecart.xo, minecart.x, partialTick);
+        double lerpY = MathHelper.lerp(minecart.yo, minecart.y, partialTick);
+        double lerpZ = MathHelper.lerp(minecart.zo, minecart.z, partialTick);
+        Vec3 vec3 = minecart.getPos(lerpX, lerpY, lerpZ); // Opposite of velocity vector?
+        double lerpXRot = MathHelper.lerp(minecart.xRotO, minecart.xRot, partialTick);
 
-        Tessellator tessellator = Tessellator.instance;
-        double d3 = minecart.xo + (minecart.x - minecart.xo) * (double)f1;
-        double d4 = minecart.yo + (minecart.y - minecart.yo) * (double)f1;
-        double d5 = minecart.zo + (minecart.z - minecart.zo) * (double)f1;
-        double d6 = 0.30000001192092896D;
-        Vec3d vec3d = minecart.func_514_g(d3, d4, d5);
-        float f2 = minecart.xRotO + (minecart.xRot - minecart.xRotO) * f1;
-        if(vec3d != null)
-        {
-            Vec3d vec3d1 = minecart.func_515_a(d3, d4, d5, d6);
-            Vec3d vec3d2 = minecart.func_515_a(d3, d4, d5, -d6);
-            if(vec3d1 == null)
-            {
-                vec3d1 = vec3d;
+        double renderX = x;
+        double renderY = y;
+        double renderZ = z;
+        double renderYaw = yaw;
+        boolean doAFlip = false;
+        if(vec3 != null) {
+//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.5, z), Vec3.getTempVec3(-(vec3.x - lerpX), -(vec3.y - lerpY), -(vec3.z - lerpZ)), 1.5, 1, 0, 0, 1);
+            final double scalar = 0.3D;
+            Vec3 forVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, scalar);
+            Vec3 backVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, -scalar);
+            if(forVec == null) {
+                forVec = vec3;
             }
-            if(vec3d2 == null)
-            {
-                vec3d2 = vec3d;
+            if(backVec == null) {
+                backVec = vec3;
             }
-            d += vec3d.xCoord - d3;
-            d1 += (vec3d1.yCoord + vec3d2.yCoord) / 2D - d4;
-            d2 += vec3d.zCoord - d5;
-            Vec3d vec3d3 = vec3d2.addVector(-vec3d1.xCoord, -vec3d1.yCoord, -vec3d1.zCoord);
-            if(vec3d3.lengthVector() != 0.0D)
-            {
-                vec3d3 = vec3d3.normalize();
-                f = (float)((java.lang.Math.atan2(vec3d3.zCoord, vec3d3.xCoord) * 180D) / 3.1415926535897931D);
-                f2 = (float)(java.lang.Math.atan(vec3d3.yCoord) * 73D);
+
+//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.6, z), Vec3.getTempVec3(forVec.x - lerpX, forVec.y - lerpY, forVec.z - lerpZ), 1.5, 0, 1, 0, 1);
+//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.7, z), Vec3.getTempVec3(backVec.x - lerpX, backVec.y - lerpY, backVec.z - lerpZ), 1.5, 0, 0, 1, 1);
+
+            renderX += vec3.x - lerpX;
+            renderY += (forVec.y + backVec.y) / 2D - lerpY;
+            renderZ += vec3.z - lerpZ;
+            Vec3 velVec = backVec.add(-forVec.x, -forVec.y, -forVec.z);
+            if(velVec.length() != 0.0D) {
+                velVec = velVec.normalize();
+                renderYaw = Math.toDegrees(Math.atan2(velVec.z, velVec.x));
+                lerpXRot = Math.atan(velVec.y) * 73D;
             }
+
+            Vec3 realVecVec = Vec3.getTempVec3(minecart.xd, minecart.yd, minecart.zd);
+
+            doAFlip = velVec.dotProduct(realVecVec) < 0;
+
+//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.8, z), Vec3.getTempVec3(velVec.x, velVec.y, velVec.z), 1.5, 0, 1, 1, 1);
         }
-        GL11.glTranslatef((float)d, (float)d1, (float)d2);
-        GL11.glRotatef(180F - f, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-f2, 0.0F, 0.0F, 1.0F);
-        float f3 = (float)minecart.minecartTimeSinceHit - f1;
-        float f4 = (float)minecart.minecartCurrentDamage - f1;
-        if(f4 < 0.0F)
-        {
-            f4 = 0.0F;
+        GL11.glTranslated(renderX, renderY, renderZ);
+        GL11.glRotated(180F - renderYaw, 0.0F, 1.0F, 0.0F);
+        GL11.glRotated(-lerpXRot, 0.0F, 0.0F, 1.0F);
+        double hurtAngle = minecart.timeSinceHit - partialTick;
+        double currentDamage = minecart.currentDamage - partialTick;
+        if(currentDamage < 0.0F) {
+            currentDamage = 0.0F;
         }
-        if(f3 > 0.0F)
-        {
-            GL11.glRotatef(((MathHelper.sin(f3) * f3 * f4) / 10F) * (float)minecart.minecartRockDirection, 1.0F, 0.0F, 0.0F);
+        if(hurtAngle > 0.0F) {
+            GL11.glRotated(((Math.sin(hurtAngle) * hurtAngle * currentDamage) / 10F) * (float)minecart.hurtDirection, 1.0F, 0.0F, 0.0F);
         }
-        if(minecart.minecartType != 0)
-        {
-            TextureRegistry.blockAtlas.bindTexture();
-            float f5 = 0.75F;
-            GL11.glScalef(f5, f5, f5);
+        // Render block in cart
+        if(minecart.type != MinecartEntity.PASSENGER_CART) {
+            TextureRegistry.blockAtlas.bind();
+            final float scale = 0.75F;
+            GL11.glScalef(scale, scale, scale);
             GL11.glTranslatef(0.0F, 0.3125F, 0.0F);
             GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled()) {
-            	LightmapHelper.setLightmapCoord(minecart.getLightmapCoord(f1));
-            }else if(Global.accessor.isFullbrightEnabled()) {
-            	
-            }else {
-            	brightness = minecart.getBrightness(f1);
+                LightmapHelper.setLightmapCoord(minecart.getLightmapCoord(partialTick));
+            } else if(!Global.accessor.isFullbrightEnabled()) {
+                brightness = minecart.getBrightness(partialTick);
+            }
+
+            GL11.glPushMatrix();
+            if (doAFlip){
+                GL11.glRotatef(180, 0, 1, 0);
             }
-            if(minecart.minecartType == 1)
-            {
-                BlockModelDispatcher.getInstance().getDispatch(Block.chestPlanksOak).renderBlockOnInventory(tessellator, 0, brightness, null);
-            } else
-            if(minecart.minecartType == 2)
-            {
-                if (minecart.fuel > 0)
-                {
-                    BlockModelDispatcher.getInstance().getDispatch(Block.furnaceStoneActive).renderBlockOnInventory(tessellator, 0, brightness, null);
-                }
-                else
-                {
-                    BlockModelDispatcher.getInstance().getDispatch(Block.furnaceStoneIdle).renderBlockOnInventory(tessellator, 0, brightness, null);
-                }
+            switch (minecart.type){
+                case MinecartEntity.CHEST_CART:
+                    BlockModelDispatcher.getInstance().getDispatch(Blocks.CHEST_PLANKS_OAK).renderBlockOnInventory(tessellator, 0, brightness, null);
+                    break;
+                case MinecartEntity.FURNACE_CART:
+                    if (minecart.fuel > 0) {
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_ACTIVE).renderBlockOnInventory(tessellator, 0, brightness, null);
+                    } else {
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_IDLE).renderBlockOnInventory(tessellator, 0, brightness, null);
+                    }
+                    break;
             }
+            GL11.glPopMatrix();
             GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
             GL11.glTranslatef(0.0F, -0.3125F, 0.0F);
-            GL11.glScalef(1.0F / f5, 1.0F / f5, 1.0F / f5);
+            GL11.glScalef(1.0F / scale, 1.0F / scale, 1.0F / scale);
         }
-        loadTexture("/assets/minecraft/textures/entity/cart.png");
+        bindTexture("/assets/minecraft/textures/entity/cart.png");
         GL11.glScalef(-1F, -1F, 1.0F);
         modelMinecart.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
         GL11.glPopMatrix();
     }
 
-    @Override
-    public void doRender(Tessellator tessellator, EntityMinecart entity, double x, double y, double z,
-                         float yaw, float partialTick)
-    {
-        renderMinecart(entity, x, y, z, yaw, partialTick);
+    private void drawDebugVec(Tessellator tessellator, Vec3 pos, Vec3 vec, double scale, float r, float g, float b, float a){
+        if (pos == null || vec == null) return;
+        GL11.glLineWidth(10);
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_TEXTURE_2D);
+        tessellator.startDrawing(GL11.GL_LINES);
+        tessellator.setColorRGBA_F(r, g, b, a);
+        tessellator.addVertex(pos.x, pos.y, pos.z);
+        tessellator.addVertex(
+            pos.x + vec.x * scale,
+            pos.y + vec.y * scale,
+            pos.z + vec.z * scale);
+        tessellator.draw();
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GL11.glEnable(GL11.GL_LIGHTING);
     }
-
-    protected ModelBase modelMinecart;
+    protected BaseModel modelMinecart;
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 160f35626..cb82b49ef 100644
--- a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -1,37 +1,277 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelBiped;
+import net.minecraft.client.render.model.BaseModel;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.Global;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntityLiving, ModelBiped, ModelRenderer, 
-//            ItemStack, Block, RenderBlocks, Item, 
-//            RenderManager, ItemRenderer
+//            Render, BaseModel, Mob, MathHelper,
+//            RenderManager, Tessellator, FontRenderer, Entity
 
-public class MobRenderer<T extends EntityLiving> extends LivingRenderer<T>
+public class MobRenderer<T extends Mob> extends EntityRenderer<T>
 {
+    public static final int MAX_ARMOR_LAYERS = 4;
+    protected BaseModel mainModel;
+    protected BaseModel armorModel;
+    protected BaseModel overlayModel;
+    protected String overlayTexture;
+    private final Minecraft mc;
 
-    public MobRenderer(ModelBiped model, float shadowSize)
+    public MobRenderer(BaseModel model, float shadowSize)
     {
-        super(model, shadowSize);
-        modelBipedMain = model;
+        this.mainModel = model;
+        this.shadowSize = shadowSize;
+        this.mc = Minecraft.getMinecraft(this);
     }
 
-	@Override
-	protected void renderEquippedItems(T entity, float f) {
-		ItemStack itemstack = entity.getHeldItem();
-		if(itemstack != null) {
-			GL11.glPushMatrix();
-			modelBipedMain.bipedRightArm.postRender(0.0625F);
-			ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack, true);
-			GL11.glPopMatrix();
-		}
-	}
 
-    protected ModelBiped modelBipedMain;
+    public void setArmorModel(BaseModel armor)
+    {
+        armorModel = armor;
+    }
+    public void setOverlayModel(BaseModel modelbase, String texture)
+    {
+        overlayModel = modelbase;
+        overlayTexture = texture;
+    }
+
+    public void render(Tessellator tessellator, T entity, double x, double y, double z,
+                       float yaw, float partialTick)
+    {
+        GL11.glPushMatrix();
+        GL11.glDisable(GL11.GL_CULL_FACE);
+        mainModel.onGround = getSwingProgress(entity, partialTick);
+        if (armorModel != null) armorModel.onGround = mainModel.onGround;
+        if (overlayModel != null) overlayModel.onGround = mainModel.onGround;
+        mainModel.isRiding = entity.isPassenger();
+        if (armorModel != null) armorModel.isRiding = mainModel.isRiding;
+        if (overlayModel != null) overlayModel.isRiding = mainModel.isRiding;
+        try
+        {
+            float bodyYaw = entity.yBodyRotO + (entity.yBodyRot - entity.yBodyRotO) * partialTick;
+            float headYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
+            float headPitch = entity.xRotO + (entity.xRot - entity.xRotO) * partialTick;
+            translateModel(entity, x, y, z);
+            float limbSway = limbSway(entity, partialTick);
+            setupRotations(entity, limbSway, bodyYaw, partialTick);
+            float scale = 0.0625F;
+            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            GL11.glScalef(-1F, -1F, 1.0F);
+            setupScale(entity, partialTick);
+            GL11.glTranslatef(0.0F, -24F * scale - 0.0078125F, 0.0F);
+            float walkSpeed = entity.walkAnimSpeedO + (entity.walkAnimSpeed - entity.walkAnimSpeedO) * partialTick;
+            float walkProgress = entity.walkAnimPos - entity.walkAnimSpeed * (1.0F - partialTick);
+            if(walkSpeed > 1.0F)
+            {
+                walkSpeed = 1.0F;
+            }
+            loadEntityTexture(entity);
+            GL11.glEnable(GL11.GL_ALPHA_TEST);
+            mainModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
+            mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+            if (overlayModel != null)
+            {
+                overlayModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
+                bindTexture(overlayTexture);
+                overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+            }
+            if (armorModel != null) armorModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
+            for(int renderPass = 0; renderPass < MAX_ARMOR_LAYERS; renderPass++)
+            {
+                if(prepareArmor(entity, renderPass, partialTick))
+                {
+                    armorModel.setLivingAnimations(entity, walkProgress, walkSpeed, partialTick);
+                    armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    GL11.glDisable(GL11.GL_BLEND);
+                    GL11.glEnable(GL11.GL_ALPHA_TEST);
+                }
+            }
+
+            renderAdditional(entity, partialTick);
+            float f9 = entity.getBrightness(partialTick);
+            if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) f9 = 1.0f;
+            int j = getOverlayColor(entity, f9, partialTick);
+            if((j >> 24 & 0xff) > 0 || entity.hurtTime > 0 || entity.deathTime > 0)
+            {
+                GL11.glDisable(GL11.GL_TEXTURE_2D);
+                GL11.glDisable(GL11.GL_ALPHA_TEST);
+                GL11.glEnable(GL11.GL_BLEND);
+                GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+                GL11.glDepthFunc(514);
+                if(entity.hurtTime > 0 || entity.deathTime > 0)
+                {
+                    GL11.glColor4f(f9, 0.0F, 0.0F, 0.4F);
+                    mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    if (overlayModel != null) overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    for(int k = 0; k < MAX_ARMOR_LAYERS; k++)
+                    {
+                        if(prepareArmor(entity, k, partialTick))
+                        {
+                            GL11.glColor4f(f9, 0.0F, 0.0F, 0.4F);
+                            armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                        }
+                    }
+
+                }
+                if((j >> 24 & 0xff) > 0)
+                {
+                    float f10 = (float)(j >> 16 & 0xff) / 255F;
+                    float f11 = (float)(j >> 8 & 0xff) / 255F;
+                    float f12 = (float)(j & 0xff) / 255F;
+                    float f13 = (float)(j >> 24 & 0xff) / 255F;
+                    GL11.glColor4f(f10, f11, f12, f13);
+                    mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    if (overlayModel != null) overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                    for(int l = 0; l < MAX_ARMOR_LAYERS; l++)
+                    {
+                        if(prepareArmor(entity, l, partialTick))
+                        {
+                            GL11.glColor4f(f10, f11, f12, f13);
+                            armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
+                        }
+                    }
+
+                }
+                GL11.glDepthFunc(GL11.GL_LEQUAL);
+                GL11.glDisable(GL11.GL_BLEND);
+                GL11.glEnable(GL11.GL_ALPHA_TEST);
+                GL11.glEnable(GL11.GL_TEXTURE_2D);
+            }
+            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        }
+        catch(Exception exception)
+        {
+            exception.printStackTrace();
+        }
+        GL11.glEnable(GL11.GL_CULL_FACE);
+        GL11.glPopMatrix();
+        renderSpecials(tessellator, entity, x, y, z);
+    }
+
+    protected void translateModel(T entity, double x, double y, double z)
+    {
+        GL11.glTranslatef((float)x, (float)y, (float)z);
+    }
+
+    protected void setupRotations(T entity, float ticksExisted, float bodyYaw, float partialTick)
+    {
+        GL11.glRotatef(180F - bodyYaw, 0.0F, 1.0F, 0.0F);
+        if(entity.deathTime > 0)
+        {
+            float rotationProgress = ((((float)entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
+            rotationProgress = MathHelper.sqrt_float(rotationProgress);
+            if(rotationProgress > 1.0F)
+            {
+                rotationProgress = 1.0F;
+            }
+            GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
+        }
+    }
+
+    protected float getSwingProgress(T entity, float partialTick)
+    {
+        return entity.getSwingProgress(partialTick);
+    }
+
+    protected float limbSway(T entity, float partialTick)
+    {
+        return (float)entity.tickCount + partialTick;
+    }
+
+    protected void renderAdditional(T entity, float f)
+    {
+    }
+
+    protected boolean prepareArmor(T entity, int layer, float partialTick)
+    {
+        return false;
+    }
+
+    protected float getMaxDeathRotation(T entity)
+    {
+        return 90F;
+    }
+
+    protected int getOverlayColor(T entity, float brightness, float partialTick)
+    {
+        return 0;
+    }
+
+    protected void setupScale(T entity, float partialTick)
+    {
+    }
+
+    protected void renderSpecials(Tessellator tessellator, T entity, double d, double d1, double d2)
+    {
+        if(mc.canRenderEntityLabel())
+        {
+            renderLivingLabel(tessellator, entity, Integer.toString(entity.id), d, d1, d2, 64, false);
+        }
+        else if (!entity.nickname.isEmpty())
+        {
+            renderLivingLabel(tessellator, entity, entity.getDisplayName(), d, d1, d2, 64, true);
+        }
+    }
+
+    protected void renderLivingLabel(Tessellator tessellator, T entity, String s, double d, double d1, double d2, int maxDistance, boolean depthTest)
+    {
+        final float f = (float) renderDispatcher.camera.distanceTo(entity);
+        if (f > maxDistance)
+        {
+            return;
+        }
+        final FontRenderer fontrenderer = getFontRenderer();
+        final float f1 = 1.6F;
+        final float f2 = 0.01666667F * f1;
+        GL11.glPushMatrix();
+        GL11.glTranslatef((float) d + 0.0F, (float) d1 + 2.3F, (float) d2);
+        GL11.glNormal3f(0.0F, 1.0F, 0.0F);
+        GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
+        GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
+        GL11.glScalef(-f2, -f2, f2);
+        GL11.glDisable(2896 /* GL_LIGHTING */);
+        GL11.glDepthMask(false);
+        if (!depthTest) GL11.glDisable(2929 /* GL_DEPTH_TEST */);
+        GL11.glEnable(3042 /* GL_BLEND */);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        byte byte0 = 0;
+        GL11.glDisable(3553 /* GL_TEXTURE_2D */);
+        tessellator.startDrawingQuads();
+        final int j = fontrenderer.getStringWidth(s) / 2;
+        tessellator.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
+        tessellator.addVertex(-j - 1, -1 + byte0, 0.0D);
+        tessellator.addVertex(-j - 1, 8 + byte0, 0.0D);
+        tessellator.addVertex(j + 1, 8 + byte0, 0.0D);
+        tessellator.addVertex(j + 1, -1 + byte0, 0.0D);
+        tessellator.draw();
+        GL11.glEnable(3553 /* GL_TEXTURE_2D */);
+        fontrenderer.drawString(s, -fontrenderer.getStringWidth(s) / 2, byte0, 0x20ffffff);
+        if (!depthTest) GL11.glEnable(2929 /* GL_DEPTH_TEST */);
+        GL11.glDepthMask(true);
+        fontrenderer.drawString(s, -fontrenderer.getStringWidth(s) / 2, byte0, 0xFFFFFF);
+        GL11.glEnable(2896 /* GL_LIGHTING */);
+        GL11.glDisable(3042 /* GL_BLEND */);
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GL11.glPopMatrix();
+    }
+    public void loadEntityTexture(T entity)
+    {
+        if (!Minecraft.getMinecraft(this).gameSettings.mobVariants.value)
+        {
+            bindTexture(entity.getDefaultEntityTexture());
+        }
+        else
+        {
+            bindTexture(entity.getEntityTexture());
+        }
+    }
 }
